local _G = _G

DoubleBinary_XPBarLocation = ""

local DoubleBinary_DebugMode = false

DoubleBinary_Class = select(2, UnitClass("player"))
DoubleBinary_Font = "Interface\\AddOns\\DoubleBinary\\fonts\\LADYIC__.ttf"

function DoubleBinary_OnLoad (self)
	framename = self:GetName(self)
	
	--self:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	if DoubleBinary_DebugMode == true then
		local r = math.random()
		local g = math.random()
		local b = math.random()
		local a = 0.5
		if framename == "DoubleBinary_MasterFrame" then
			a = 0.1
		end
		_G[framename.."BG"]:SetTexture(r,g,b,a)
		_G[framename.."Name"]:SetText(framename)
	end
	if framename == "DoubleBinary_XPBarFrame"..DoubleBinary_XPBarLocation then
		if _G[framename]:GetHeight() > _G[framename]:GetWidth() then
			_G[framename]:SetWidth(20)
		else
			_G[framename]:SetHeight(20)
		end
	end
end

function DoubleBinary_Event (self, event, ...)
	--local arg1 = ...;
	--if arg1 ~= nil then print (arg1) end
	--if ( event == "PLAYER_ENTERING_WORLD" ) then
	--	print(self)
	--	return;
	--end
end

function DoubleBinary_BarAnchor(frame, frametext, text, buttons, rows, point, relativeFrame, relativePoint, ofsx, ofsy, fwidth, fheight, space, r, g, b)
	frame:SetBackdrop({bgFile = "Interface\\AddOns\\DoubleBinary\\textures\\WHITE8x8"})
	frame:SetBackdropColor(r,g,b,0)
	frame:SetWidth(((fwidth+space)*buttons)/rows)
	frame:SetHeight((fheight+space)*rows)
	frame:SetFrameStrata("BACKGROUND")
	frame:ClearAllPoints()
	frame:SetParent(relativeFrame)
	frame:SetPoint(point, relativeFrame, relativePoint, ofsx, ofsy);
	frame:SetClampedToScreen(true)
	frametext:SetPoint("TOPLEFT", frame, "TOPLEFT", 3, -3)
	frametext:SetFont(DoubleBinary_Font, 12, "OUTLINE")
	frametext:SetWordWrap(enable)
	frametext:SetText(text)
	frametext:Hide()
end

function DoubleBinary_BarButtonSort(but, index, rows, anchor, alpha, mouseover, frame, maxb, bsize, scale)
		local button = _G[but..index]
    button:ClearAllPoints()
    button:SetAlpha(alpha)
	button:SetScale(scale)
    if _G[but..index.."HotKey"] then
        _G[but..index.."HotKey"]:SetJustifyH("Right")
        _G[but..index.."HotKey"]:SetPoint("TOPRIGHT", button, "TOPRIGHT", 2,0)
		_G[but..index.."HotKey"]:SetFont(DoubleBinary_Font, 14, "OUTLINE")

    end
    if index == 1 then
		if rows == maxb then
			button:SetPoint("TOP",anchor,"TOP",0,-5)
		else
			button:SetPoint("LEFT",anchor,"LEFT",5,0)
		end
    elseif rows==12 then
        button:SetPoint("TOP", _G[but..(index-1)],"BOTTOM",0,-8)
    else
        button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", 8, 0)
    end
end

--self:RegisterEvent("PLAYER_ENTERING_WORLD");

print("The `DoubleBinary` Project")
print("Welcome "..string.lower(DoubleBinary_Class))
print(" - Main Module loaded.")

--hooksecurefunc("PLAYER_ENTERING_WORLD", function()
--	if (IsAddOnLoaded("DoubleBinary_Actionbars")) then
--		print("YadaYada")
--	end
--end)